;;TAG.LSP Copyright 1998 HyperPics all rights reserved
;;
;;  Author: Lee Ambrosius,
;;             HyperPics

;;TAG
;;The tag allows the user to place a leader, (w/o an arrow attached to it), 
;;that has a numbered bubble attached at the opposite end.  The number counts 
;;upward in an increment of one from the users defined number.  Some people
;;refer to this type of routine as a lollipop maker, and if you don't know why
;;you will if you try it.


(defun MYERROR (S)                    ;;error trap program
   (if (/= S "\nFunction cancelled" )
   (prompt "\nEnding Tag routine..." ) )
   (setvar "OSMODE" OS)
   (setvar "CMDECHO" CMD)
   (command "._undo" "end")
   (setq *ERROR* OLDERR )
  (princ) 
)


(defun c:TAG ()
  (graphscr)
  (setq CMD (getvar "cmdecho"))
  (setvar "cmdecho" 0)
  (setq OLDERR *ERROR*)
  (setq *ERROR* MYERROR )  
  (command "._undo" "begin")
  (setq OS (getvar "osmode"))
  (setvar "osmode" 0)
  (setq TAGNUM (getint "\nEnter starting number: "))
  (while (setq PT1 (getpoint "\nPick the leader endpoint: "))
    (setq PT2 (getpoint PT1 "\nPick the tag center point: "))
    (setq RAD (/ (getvar "dimscale") 4.0))
    (setq ANG (angle PT2 PT1))
    (setq DIST (distance PT1 PT2))
    (setq LDRPT (polar PT2 ANG RAD))
    (command "line" PT1 LDRPT ""
             "circle" PT2 RAD
             "text" "m" PT2 (/ RAD 2) 0 (itoa TAGNUM)
    )
    (setq TAGNUM (1+ TAGNUM))
  )
  (redraw)
  (setvar "osmode" OS)
  (setvar "cmdecho" CMD)
  (setq *ERROR* OLDERR )  
  (command "._undo" "end")
 (princ)
)

(princ)
  (prompt "\nEnter TAG for the tag routine.")
(princ)
